<?php

namespace Litecms\Weeklymatching;

use User;

class Weeklymatching
{
    /**
     * $weekly_matching object.
     */
    protected $weekly_matching;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Weeklymatching\Interfaces\WeeklyMatchingRepositoryInterface $weekly_matching)
    {
        $this->weekly_matching = $weekly_matching;
    }

    /**
     * Returns count of weeklymatching.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.weekly_matching.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->weekly_matching->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\WeeklyMatchingUserCriteria());
        }

        $weekly_matching = $this->weekly_matching->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('weeklymatching::' . $view, compact('weekly_matching'))->render();
    }
}
